Handle failure of core.worktree to identify the working directory.
[git/dscho.git] / git-pull.sh
blob1a4729f7bb29205fb7bc251887dcd4f5237f1659
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
9 SUBDIRECTORY_OK=Yes
10 OPTIONS_SPEC=
11 . git-sh-setup
12 set_reflog_action "pull $*"
13 require_work_tree
14 cd_to_toplevel
17 die_conflict () {
18 git diff-index --cached --name-status -r --ignore-submodules HEAD --
19 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
20 die "Pull is not possible because you have unmerged files.
21 Please, fix them up in the work tree, and then use 'git add/rm <file>'
22 as appropriate to mark resolution, or use 'git commit -a'."
23 else
24 die "Pull is not possible because you have unmerged files."
28 die_merge () {
29 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
30 die "You have not concluded your merge (MERGE_HEAD exists).
31 Please, commit your changes before you can merge."
32 else
33 die "You have not concluded your merge (MERGE_HEAD exists)."
37 test -z "$(git ls-files -u)" || die_conflict
38 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
40 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
41 log_arg= verbosity= progress=
42 merge_args=
43 curr_branch=$(git symbolic-ref -q HEAD)
44 curr_branch_short="${curr_branch#refs/heads/}"
45 rebase=$(git config --bool branch.$curr_branch_short.rebase)
46 while :
48 case "$1" in
49 -q|--quiet)
50 verbosity="$verbosity -q" ;;
51 -v|--verbose)
52 verbosity="$verbosity -v" ;;
53 --progress)
54 progress=--progress ;;
55 -n|--no-stat|--no-summary)
56 diffstat=--no-stat ;;
57 --stat|--summary)
58 diffstat=--stat ;;
59 --log|--no-log)
60 log_arg=$1 ;;
61 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
62 no_commit=--no-commit ;;
63 --c|--co|--com|--comm|--commi|--commit)
64 no_commit=--commit ;;
65 --sq|--squ|--squa|--squas|--squash)
66 squash=--squash ;;
67 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
68 squash=--no-squash ;;
69 --ff)
70 no_ff=--ff ;;
71 --no-ff)
72 no_ff=--no-ff ;;
73 --ff-only)
74 ff_only=--ff-only ;;
75 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
76 --strateg=*|--strategy=*|\
77 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
78 case "$#,$1" in
79 *,*=*)
80 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
81 1,*)
82 usage ;;
84 strategy="$2"
85 shift ;;
86 esac
87 strategy_args="${strategy_args}-s $strategy "
89 -X*)
90 case "$#,$1" in
91 1,-X)
92 usage ;;
93 *,-X)
94 xx="-X $(git rev-parse --sq-quote "$2")"
95 shift ;;
96 *,*)
97 xx=$(git rev-parse --sq-quote "$1") ;;
98 esac
99 merge_args="$merge_args$xx "
101 -r|--r|--re|--reb|--reba|--rebas|--rebase)
102 rebase=true
104 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
105 rebase=false
107 -h|--h|--he|--hel|--help)
108 usage
111 # Pass thru anything that may be meant for fetch.
112 break
114 esac
115 shift
116 done
118 error_on_no_merge_candidates () {
119 exec >&2
120 for opt
122 case "$opt" in
123 -t|--t|--ta|--tag|--tags)
124 echo "Fetching tags only, you probably meant:"
125 echo " git fetch --tags"
126 exit 1
127 esac
128 done
130 if test true = "$rebase"
131 then
132 op_type=rebase
133 op_prep=against
134 else
135 op_type=merge
136 op_prep=with
139 curr_branch=${curr_branch#refs/heads/}
140 upstream=$(git config "branch.$curr_branch.merge")
141 remote=$(git config "branch.$curr_branch.remote")
143 if [ $# -gt 1 ]; then
144 if [ "$rebase" = true ]; then
145 printf "There is no candidate for rebasing against "
146 else
147 printf "There are no candidates for merging "
149 echo "among the refs that you just fetched."
150 echo "Generally this means that you provided a wildcard refspec which had no"
151 echo "matches on the remote end."
152 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
153 echo "You asked to pull from the remote '$1', but did not specify"
154 echo "a branch. Because this is not the default configured remote"
155 echo "for your current branch, you must specify a branch on the command line."
156 elif [ -z "$curr_branch" ]; then
157 echo "You are not currently on a branch, so I cannot use any"
158 echo "'branch.<branchname>.merge' in your configuration file."
159 echo "Please specify which remote branch you want to use on the command"
160 echo "line and try again (e.g. 'git pull <repository> <refspec>')."
161 echo "See git-pull(1) for details."
162 elif [ -z "$upstream" ]; then
163 echo "You asked me to pull without telling me which branch you"
164 echo "want to $op_type $op_prep, and 'branch.${curr_branch}.merge' in"
165 echo "your configuration file does not tell me, either. Please"
166 echo "specify which branch you want to use on the command line and"
167 echo "try again (e.g. 'git pull <repository> <refspec>')."
168 echo "See git-pull(1) for details."
169 echo
170 echo "If you often $op_type $op_prep the same branch, you may want to"
171 echo "use something like the following in your configuration file:"
172 echo
173 echo " [branch \"${curr_branch}\"]"
174 echo " remote = <nickname>"
175 echo " merge = <remote-ref>"
176 test rebase = "$op_type" &&
177 echo " rebase = true"
178 echo
179 echo " [remote \"<nickname>\"]"
180 echo " url = <url>"
181 echo " fetch = <refspec>"
182 echo
183 echo "See git-config(1) for details."
184 else
185 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
186 echo "from the remote, but no such ref was fetched."
188 exit 1
191 test true = "$rebase" && {
192 if ! git rev-parse -q --verify HEAD >/dev/null
193 then
194 # On an unborn branch
195 if test -f "$GIT_DIR/index"
196 then
197 die "updating an unborn branch with changes added to the index"
199 else
200 git update-index --ignore-submodules --refresh &&
201 git diff-files --ignore-submodules --quiet &&
202 git diff-index --ignore-submodules --cached --quiet HEAD -- ||
203 die "refusing to pull with rebase: your working tree is not up-to-date"
205 oldremoteref= &&
206 . git-parse-remote &&
207 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
208 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
209 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
211 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
212 then
213 oldremoteref="$reflog"
214 break
216 done
218 orig_head=$(git rev-parse -q --verify HEAD)
219 git fetch $verbosity $progress --update-head-ok "$@" || exit 1
221 curr_head=$(git rev-parse -q --verify HEAD)
222 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
223 then
224 # The fetch involved updating the current branch.
226 # The working tree and the index file is still based on the
227 # $orig_head commit, but we are merging into $curr_head.
228 # First update the working tree to match $curr_head.
230 echo >&2 "Warning: fetch updated the current branch head."
231 echo >&2 "Warning: fast-forwarding your working tree from"
232 echo >&2 "Warning: commit $orig_head."
233 git update-index -q --refresh
234 git read-tree -u -m "$orig_head" "$curr_head" ||
235 die 'Cannot fast-forward your working tree.
236 After making sure that you saved anything precious from
237 $ git diff '$orig_head'
238 output, run
239 $ git reset --hard
240 to recover.'
244 merge_head=$(sed -e '/ not-for-merge /d' \
245 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
246 tr '\012' ' ')
248 case "$merge_head" in
250 error_on_no_merge_candidates "$@"
252 ?*' '?*)
253 if test -z "$orig_head"
254 then
255 die "Cannot merge multiple branches into empty head"
257 if test true = "$rebase"
258 then
259 die "Cannot rebase onto multiple branches"
262 esac
264 if test -z "$orig_head"
265 then
266 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
267 git read-tree --reset -u HEAD || exit 1
268 exit
271 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
272 case "$rebase" in
273 true)
274 eval="git-rebase $diffstat $strategy_args $merge_args"
275 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
278 eval="git-merge $diffstat $no_commit $squash $no_ff $ff_only"
279 eval="$eval $log_arg $strategy_args $merge_args"
280 eval="$eval \"\$merge_name\" HEAD $merge_head $verbosity"
282 esac
283 eval "exec $eval"